diff --git a/gcc/tree-ssa-propagate.c b/gcc/tree-ssa-propagate.c
index 4e76d97..dcb064f 100644
--- a/gcc/tree-ssa-propagate.c
+++ b/gcc/tree-ssa-propagate.c
@@ -153,7 +153,7 @@ static sbitmap bb_in_list;
    definition has changed.  SSA edges are def-use edges in the SSA
    web.  For each D-U edge, we store the target statement or PHI node
    U.  */
-static vec<gimple> interesting_ssa_edges;
+static vec<gimple *> interesting_ssa_edges;
 
 /* Identical to INTERESTING_SSA_EDGES.  For performance reasons, the
    list of SSA edges is split into two.  One contains all SSA edges
@@ -169,7 +169,7 @@ static vec<gimple> interesting_ssa_edges;
    don't use a separate worklist for VARYING edges, we end up with
    situations where lattice values move from
    UNDEFINED->INTERESTING->VARYING instead of UNDEFINED->VARYING.  */
-static vec<gimple> varying_ssa_edges;
+static vec<gimple *> varying_ssa_edges;
 
 
 /* Return true if the block worklist empty.  */
@@ -264,7 +264,7 @@ add_ssa_edge (tree var, bool is_varying)
 
   FOR_EACH_IMM_USE_FAST (use_p, iter, var)
     {
-      gimple use_stmt = USE_STMT (use_p);
+      gimple *use_stmt = USE_STMT (use_p);
 
       if (prop_simulate_again_p (use_stmt)
 	  && !gimple_plf (use_stmt, STMT_IN_SSA_EDGE_WORKLIST))
@@ -309,7 +309,7 @@ add_control_edge (edge e)
 /* Simulate the execution of STMT and update the work lists accordingly.  */
 
 static void
-simulate_stmt (gimple stmt)
+simulate_stmt (gimple *stmt)
 {
   enum ssa_prop_result val = SSA_PROP_NOT_INTERESTING;
   edge taken_edge = NULL;
@@ -369,7 +369,7 @@ simulate_stmt (gimple stmt)
    SSA edge is added to it in simulate_stmt.  */
 
 static void
-process_ssa_edge_worklist (vec<gimple> *worklist)
+process_ssa_edge_worklist (vec<gimple *> *worklist)
 {
   /* Drain the entire worklist.  */
   while (worklist->length () > 0)
@@ -377,7 +377,7 @@ process_ssa_edge_worklist (vec<gimple> *worklist)
       basic_block bb;
 
       /* Pull the statement to simulate off the worklist.  */
-      gimple stmt = worklist->pop ();
+      gimple *stmt = worklist->pop ();
 
       /* If this statement was already visited by simulate_block, then
 	 we don't need to visit it again here.  */
@@ -439,7 +439,7 @@ simulate_block (basic_block block)
 
       for (j = gsi_start_bb (block); !gsi_end_p (j); gsi_next (&j))
 	{
-	  gimple stmt = gsi_stmt (j);
+	  gimple *stmt = gsi_stmt (j);
 
 	  /* If this statement is already in the worklist then
 	     "cancel" it.  The reevaluation implied by the worklist
@@ -695,7 +695,7 @@ valid_gimple_call_p (tree expr)
    as their defining statement.  */
 
 void
-move_ssa_defining_stmt_for_defs (gimple new_stmt, gimple old_stmt)
+move_ssa_defining_stmt_for_defs (gimple *new_stmt, gimple *old_stmt)
 {
   tree var;
   ssa_op_iter iter;
@@ -716,8 +716,8 @@ move_ssa_defining_stmt_for_defs (gimple new_stmt, gimple old_stmt)
    A GIMPLE_CALL STMT is being replaced with GIMPLE_CALL NEW_STMT.  */
 
 static void
-finish_update_gimple_call (gimple_stmt_iterator *si_p, gimple new_stmt,
-			   gimple stmt)
+finish_update_gimple_call (gimple_stmt_iterator *si_p, gimple *new_stmt,
+			   gimple *stmt)
 {
   gimple_call_set_lhs (new_stmt, gimple_call_lhs (stmt));
   move_ssa_defining_stmt_for_defs (new_stmt, stmt);
@@ -737,7 +737,7 @@ bool
 update_gimple_call (gimple_stmt_iterator *si_p, tree fn, int nargs, ...)
 {
   va_list ap;
-  gimple new_stmt, stmt = gsi_stmt (*si_p);
+  gimple *new_stmt, *stmt = gsi_stmt (*si_p);
 
   gcc_assert (is_gimple_call (stmt));
   va_start (ap, nargs);
@@ -762,7 +762,7 @@ update_gimple_call (gimple_stmt_iterator *si_p, tree fn, int nargs, ...)
 bool
 update_call_from_tree (gimple_stmt_iterator *si_p, tree expr)
 {
-  gimple stmt = gsi_stmt (*si_p);
+  gimple *stmt = gsi_stmt (*si_p);
 
   if (valid_gimple_call_p (expr))
     {
@@ -771,7 +771,7 @@ update_call_from_tree (gimple_stmt_iterator *si_p, tree expr)
       unsigned i;
       unsigned nargs = call_expr_nargs (expr);
       vec<tree> args = vNULL;
-      gimple new_stmt;
+      gimple *new_stmt;
 
       if (nargs > 0)
         {
@@ -791,7 +791,7 @@ update_call_from_tree (gimple_stmt_iterator *si_p, tree expr)
   else if (valid_gimple_rhs_p (expr))
     {
       tree lhs = gimple_call_lhs (stmt);
-      gimple new_stmt;
+      gimple *new_stmt;
 
       /* The call has simplified to an expression
          that cannot be represented as a GIMPLE_CALL. */
@@ -887,7 +887,7 @@ ssa_propagate (ssa_prop_visit_stmt_fn visit_stmt,
    because they are not interesting for the optimizers.  */
 
 bool
-stmt_makes_single_store (gimple stmt)
+stmt_makes_single_store (gimple *stmt)
 {
   tree lhs;
 
@@ -925,7 +925,7 @@ static struct prop_stats_d prop_stats;
    PROP_VALUE. Return true if at least one reference was replaced.  */
 
 static bool
-replace_uses_in (gimple stmt, ssa_prop_get_value_fn get_value)
+replace_uses_in (gimple *stmt, ssa_prop_get_value_fn get_value)
 {
   bool replaced = false;
   use_operand_p use;
@@ -964,7 +964,7 @@ replace_uses_in (gimple stmt, ssa_prop_get_value_fn get_value)
    values from PROP_VALUE.  */
 
 static void
-replace_phi_args_in (gimple phi, ssa_prop_get_value_fn get_value)
+replace_phi_args_in (gimple *phi, ssa_prop_get_value_fn get_value)
 {
   size_t i;
   bool replaced = false;
@@ -1056,7 +1056,7 @@ substitute_and_fold (ssa_prop_get_value_fn get_value_fn,
       {
 	tree name = ssa_name (i);
 	tree val;
-	gimple def_stmt;
+	gimple *def_stmt;
 	gimple_stmt_iterator gsi;
 
 	if (!name
@@ -1096,7 +1096,7 @@ substitute_and_fold (ssa_prop_get_value_fn get_value_fn,
 	  }
 	else if (gimple_code (def_stmt) == GIMPLE_PHI)
 	  {
-	    gimple new_stmt = gimple_build_assign (name, val);
+	    gimple *new_stmt = gimple_build_assign (name, val);
 	    gimple_stmt_iterator gsi2;
 	    gsi2 = gsi_after_labels (gimple_bb (def_stmt));
 	    gsi_insert_before (&gsi2, new_stmt, GSI_SAME_STMT);
@@ -1122,8 +1122,8 @@ substitute_and_fold (ssa_prop_get_value_fn get_value_fn,
       for (i = (do_dce ? gsi_last_bb (bb) : gsi_start_bb (bb)); !gsi_end_p (i);)
 	{
           bool did_replace;
-	  gimple stmt = gsi_stmt (i);
-	  gimple old_stmt;
+	  gimple *stmt = gsi_stmt (i);
+	  gimple *old_stmt;
 	  enum gimple_code code = gimple_code (stmt);
 	  gimple_stmt_iterator oldi;
 
@@ -1295,7 +1295,7 @@ may_propagate_copy (tree dest, tree orig)
    gimple tuples representation.  */
 
 bool
-may_propagate_copy_into_stmt (gimple dest, tree orig)
+may_propagate_copy_into_stmt (gimple *dest, tree orig)
 {
   tree type_d;
   tree type_o;
@@ -1431,7 +1431,7 @@ propagate_tree_value (tree *op_p, tree val)
 void
 propagate_tree_value_into_stmt (gimple_stmt_iterator *gsi, tree val)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
 
   if (is_gimple_assign (stmt))
     {
diff --git a/gcc/tree-ssa-propagate.h b/gcc/tree-ssa-propagate.h
index 2d8d876..bee4022 100644
--- a/gcc/tree-ssa-propagate.h
+++ b/gcc/tree-ssa-propagate.h
@@ -25,7 +25,7 @@ along with GCC; see the file COPYING3.  If not see
 /* If SIM_P is true, statement S will be simulated again.  */
 
 static inline void
-prop_set_simulate_again (gimple s, bool visit_p)
+prop_set_simulate_again (gimple *s, bool visit_p)
 {
   gimple_set_visited (s, visit_p);
 }
@@ -33,7 +33,7 @@ prop_set_simulate_again (gimple s, bool visit_p)
 /* Return true if statement T should be simulated again.  */
 
 static inline bool
-prop_simulate_again_p (gimple s)
+prop_simulate_again_p (gimple *s)
 {
   return gimple_visited_p (s);
 }
@@ -62,22 +62,22 @@ enum ssa_prop_result {
 
 
 /* Call-back functions used by the value propagation engine.  */
-typedef enum ssa_prop_result (*ssa_prop_visit_stmt_fn) (gimple, edge *, tree *);
-typedef enum ssa_prop_result (*ssa_prop_visit_phi_fn) (gimple);
+typedef enum ssa_prop_result (*ssa_prop_visit_stmt_fn) (gimple *, edge *, tree *);
+typedef enum ssa_prop_result (*ssa_prop_visit_phi_fn) (gimple *);
 typedef bool (*ssa_prop_fold_stmt_fn) (gimple_stmt_iterator *gsi);
 typedef tree (*ssa_prop_get_value_fn) (tree);
 
 
 extern bool valid_gimple_rhs_p (tree);
-extern void move_ssa_defining_stmt_for_defs (gimple, gimple);
+extern void move_ssa_defining_stmt_for_defs (gimple *, gimple *);
 extern bool update_gimple_call (gimple_stmt_iterator *, tree, int, ...);
 extern bool update_call_from_tree (gimple_stmt_iterator *, tree);
 extern void ssa_propagate (ssa_prop_visit_stmt_fn, ssa_prop_visit_phi_fn);
-extern bool stmt_makes_single_store (gimple);
+extern bool stmt_makes_single_store (gimple *);
 extern bool substitute_and_fold (ssa_prop_get_value_fn, ssa_prop_fold_stmt_fn,
 				 bool);
 extern bool may_propagate_copy (tree, tree);
-extern bool may_propagate_copy_into_stmt (gimple, tree);
+extern bool may_propagate_copy_into_stmt (gimple *, tree);
 extern bool may_propagate_copy_into_asm (tree);
 extern void propagate_value (use_operand_p, tree);
 extern void replace_exp (use_operand_p, tree);
